/*
 * SPDX-License-Identifier:     GPL-2.0+
 *
 * Copyright (c) 2023 Unfolded Circle ApS
 */

#ifndef __CONFIGS_UC_REMOTE_TWO_RK3566_H
#define __CONFIGS_UC_REMOTE_TWO_RK3566_H  

#include <configs/rk3568_common.h>

#ifndef CONFIG_SPL_BUILD

#undef ROCKCHIP_DEVICE_SETTINGS
#define ROCKCHIP_DEVICE_SETTINGS \
		"stdin=serial,usbkbd\0" \
		"stdout=serial,vidconsole\0" \
		"stderr=serial,vidconsole\0"

#define CONFIG_SYS_REDUNDAND_ENVIRONMENT

#define CONFIG_MISC_INIT_R
#define CONFIG_BMP_16BPP 
#define CONFIG_BMP_24BPP 
#define CONFIG_BMP_32BPP 

#define BOOT_UPDATE_ENV \
	"loadaddr=0x2faf0800\0" \
	"devtype=mmc\0" \
	"devnum=0\0" \
	"prefix=/\0" \
	"boot_choice=R\0" \
	"boot_A=1\0" \
	"rootfs_A=/dev/mmcblk0p2\0" \
	"boot_B=3\0" \
	"rootfs_B=/dev/mmcblk0p4\0" \
	"bootlimit=0x2\0" \
	"bootcount=0\0" \
	"rollback=0\0" \
	"upgrade_available=0\0" \
	"fit_addr=0x10000000\0" \
	"recovery_offset=0x8000\0" \
	"recovery_size=0x20000\0" \
	"bootargs=console=ttyS2,1500000 fbcon=rotate:3\0" \
	"altbootcmd= " \
	"  echo \"Rollback to previous RootFs\" ; " \
	"  if test ${rollback} = 1 ; then " \
	"    echo \"No RootFs available\" " \
	"    setenv boot_choice R; " \
	"    setenv rollback 0 ; " \
	"    saveenv ; " \
	"    run recoverybootcmd; " \
	"  fi; " \
	"  setenv rollback 1 ; " \
	"  if test ${boot_choice} = A ; then " \
	"    setenv boot_choice B; " \
	"  else " \
	"    setenv boot_choice A; " \
	"  fi; " \
	"  setenv bootcount 0; " \
	"  saveenv; " \
	"  run bootcmd\0" \
	"recoverybootcmd= " \
	"  echo \"Recovery Boot\" ; " \
	"  mmc read ${fit_addr} ${recovery_offset} ${recovery_size} ; " \
	"  bootm ${fit_addr}\0"

#define CONFIG_SYS_MMC_ENV_DEV		0

#undef CONFIG_BOOTCOMMAND
#define CONFIG_BOOTCOMMAND \
	"if test ${boot_choice} != R ; then " \
	"  if test ${upgrade_available} = 1 ; then " \
	"    setexpr bootcount ${bootcount} + 1 ; " \
	"    saveenv; " \
	"    if test ${bootcount} > ${bootlimit} ; then " \
	"      echo \"Warning: Bootlimit (${bootlimit}) exceeded.\" ; " \
	"      run altbootcmd ; " \
	"    fi ; " \
	"  fi ; " \
	"fi ; " \
	"if test ${boot_choice} = A ; then " \
	"  setenv distro_bootpart ${boot_A} ; " \
	"  setenv rootfs ${rootfs_A} ; " \
	"else " \
	"  if test ${boot_choice} = B ; then " \
	"    setenv distro_bootpart ${boot_B} ; " \
	"    setenv rootfs ${rootfs_B} ; " \
	"  else " \
	"    echo \"Boot recovery partition!\" ; " \
	"    run recoverybootcmd; " \
	"  fi ; " \
	"fi ; " \
	"echo \"Boot over ${devtype} ${devnum}:${distro_bootpart} (boot choice ${boot_choice})!\" ; " \
	"run scan_dev_for_extlinux; "

#undef CONFIG_EXTRA_ENV_SETTINGS
#define CONFIG_EXTRA_ENV_SETTINGS \
	ENV_MEM_LAYOUT_SETTINGS \
	ROCKCHIP_DEVICE_SETTINGS \
	BOOTENV \
	BOOT_UPDATE_ENV

#ifdef CONFIG_USB_FUNCTION_DFU
#define CONFIG_SET_DFU_ALT_INFO
#endif

#define DFU_ALT_BOOT_EMMC \
	"gpt raw 0x0 0x20000;" \
	"loader raw 0x20000 0xE0000;"\
	"uboot part 0 1;" \
	"boot part 0 2;" \
	"rootfs part 0 3;" \
	"userdata part 0 4\0"

#ifdef CONFIG_ANDROID_AB
#define DFU_ALT_BOOT_MTD_A \
	"gpt raw 0x0 0x20000;" \
	"loader raw 0x20000 0xE0000;"\
	"vnvm part vnvm;" \
	"uboot part uboot;" \
	"boot raw 0x700000 0x600000\0"

#define DFU_ALT_BOOT_MTD_B \
	"gpt raw 0x0 0x20000;" \
	"loader raw 0x20000 0xE0000;"\
	"vnvm part vnvm;" \
	"uboot part uboot;" \
	"boot raw 0xd00000 0x600000\0"
#else
#define DFU_ALT_BOOT_MTD \
	"gpt raw 0x0 0x20000;" \
	"loader raw 0x20000 0xE0000;"\
	"vnvm part vnvm;" \
	"uboot part uboot;" \
	"boot part boot;" \
	"rootfs partubi rootfs;" \
	"userdata partubi userdata\0"

#endif /* CONFIG_ANDROID_AB */
#endif /* CONFIG_SPL_BUILD */
#endif /* __CONFIGS_UC_REMOTE_TWO_RK3566_H */
